#!/usr/bin/env python

from os.path import abspath, commonprefix, exists, join
from os import makedirs

STORE_DIR = "/tmp/imip"

def check_dir(base, dir):
    return commonprefix([base, abspath(dir)]) == base

class FileStore:

    "A file store of tabular data."

    def __init__(self):
        self.store_dir = STORE_DIR
        if not exists(self.store_dir):
            makedirs(self.store_dir)

    def get_freebusy(self, calendar):

        "Get free/busy details from the given 'calendar'."

        dir = join(self.store_dir, calendar)
        if not check_dir(self.store_dir, dir):
            return None

        filename = join(dir, "freebusy")
        if not exists(filename):
            return None

        f = open(filename)
        try:
            l = []
            for line in f.readlines():
                l.append(line.strip().split("\t"))
            return l
        finally:
            f.close()

# vim: tabstop=4 expandtab shiftwidth=4
